{% comment %}
This is a component. It should not exist by itself, but only as an included snippet in another template.

Context requirements:
* An object "page_obj" that contains a paginator object.
* (Optional) An object "q" that contains a query string.

Make sure that that template has a pagination object called page_obj, or the template engine will crash.
For example, the surrounding template can be used in a `django.views.generic.ListView` (or more generally 
using a `django.views.generic.list.MultipleObjectsMixin`).

The pagination functionality can be further augmented with a query argument "q", such that the results on the pages can be filtered.
For this reason, the pagination component works well with the searchbar component.
{% endcomment %}

<nav class="pagination is-centered" role="pagination" aria-label="pagination">
    {% if page_obj.has_previous %}
        <a class="pagination-previous" href="?page={{page_obj.previous_page_number}}{% if q %}&q={{ q }}{% endif %}">Previous</a>
    {% else %}
        <a class="pagination-previous" disabled>Previous</a>
    {% endif %}

    {% if page_obj.has_next %}
        <a class="pagination-next" href="?page={{page_obj.next_page_number}}{% if q %}&q={{ q }}{% endif %}">Next</a>
    {% else %}
        <a class="pagination-next" disabled>Next</a>
    {% endif %}

    <ul class="pagination-list">
        {% if page_obj.has_previous and page_obj.previous_page_number > 1 %}
            <li>
                <a class="pagination-link" aria-label="Goto first page" href="?page=1{% if q %}&q={{ q }}{% endif %}">1</a>
            </li>
            {% if page_obj.previous_page_number > 2 %}
                <li>
                    <span class="pagination-ellipsis">&hellip;</span>
                </li>
            {% endif %}
        {% endif %}  
        {% if page_obj.has_previous %}
            {% with prev_page=page_obj.previous_page_number%}
                <li>
                    <a class="pagination-link" aria-label="Goto page {{prev_page}}" href="?page={{prev_page}}{% if q %}&q={{ q }}{% endif %}">{{prev_page}}</a>
                </li>
            {% endwith %}
        {% endif %}
        <li>
            <a class="pagination-link is-current" aria-label="Page {{page_obj.number}}" aria-current="page">{{page_obj.number}}</a>
        </li>
        {% if page_obj.has_next %}
            {% with next_page=page_obj.next_page_number%}
                <li>
                    <a class="pagination-link" aria-label="Goto page {{next_page}}" href="?page={{next_page}}{% if q %}&q={{ q }}{% endif %}">{{next_page}}</a>
                </li>
            {% endwith %}
        {% endif %}

        {% if page_obj.has_next and page_obj.next_page_number < page_obj.paginator.num_pages %}
            {% if page_obj.next_page_number < page_obj.paginator.num_pages|add:"-1" %}
                <li>
                    <span class="pagination-ellipsis">&hellip;</span>
                </li>
            {% endif %}
            <li>
                <a class="pagination-link" aria-label="Goto last page" href="?page={{page_obj.paginator.num_pages}}{% if q %}&q={{ q }}{% endif %}">{{page_obj.paginator.num_pages}}</a>
            </li>
        {% endif %}
    </ul>
</nav>